// Decompiled by Jad v1.5.7f. Copyright 2000 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/SiliconValley/Bridge/8617/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   gjdoc/Main.java

package gjdoc;

import gj.util.Vector;
import gjdoc.cmdline.CLParseException;
import gjdoc.cmdline.CLTemplate;
import gjdoc.cmdline.DocOptions;
import gjdoc.cmdline.FileUtil;
import gjdoc.doctree.CommentParser;
import gjdoc.doctree.DocComment;
import gjdoc.doctree.DocEmpty;
import gjdoc.doctree.DocPackage;
import gjdoc.doctree.DocVector;
import gjdoc.doctree.SkeletonNode;
import gjdoc.html.HTML;
import gjdoc.parser.GJParser;
import gjdoc.parser.ParseException;
import gjdoc.syntaxtree.CompilationUnit;
import gjdoc.visitors.DetailVisitor;
import gjdoc.visitors.HTMLPageVisitor;
import gjdoc.visitors.PackageListVisitor;
import gjdoc.visitors.SummaryVisitor;
import gjdoc.visitors.SyntaxToDocVisitor;
import java.io.*;

public class Main
{
    private static class FileExtensionFilter
        implements FilenameFilter
    {

        public boolean accept(File file, String s)
        {
            return s.indexOf(ext) + ext.length() == s.length();
        }

        String ext;

        public FileExtensionFilter(String s)
        {
            ext = s;
        }
    }


    public Main()
    {
    }

    protected static void processFile(String s, Vector vector)
    {
        File file = null;
        try
        {
            //if(s.indexOf(File.separatorChar) == 0)
            {
                try
                {
                    file = new File(s);
                }
                catch(NullPointerException nullpointerexception)
                {
                    throw new FileNotFoundException();
                }
                if(file == null)
                    throw new FileNotFoundException();
            } //else
            {
                /*if(s.indexOf(File.separatorChar) == -1)
                    file = FileUtil.openPackage(s, vector);
                if(file == null)
                    file = FileUtil.openFile(s, vector);*/
                if(file.isDirectory())
                {
                    File afile[] = file.listFiles(JavaFilter);
                    for(int i = 0; i < afile.length; i++)
                        documentFile(new FileReader(afile[i]), afile[i].getName());

                } else
                {
                    documentFile(new FileReader(file), file.getName());
                }
            }
        }
        catch(FileNotFoundException filenotfoundexception)
        {
            System.err.println("Cannot find " + filenotfoundexception.getMessage() + " for parsing.");
        }
    }

    public static void documentFile(FileReader filereader, String s)
    {
        try
        {
            GJParser.ReInit(filereader);
            CompilationUnit compilationunit = GJParser.CompilationUnit();
            compilationunit.accept(SyntaxToDocVisitor.Singleton, top);
        }
        catch(ParseException parseexception)
        {
            System.err.println("Parsing error in file '" + s + "'.");
            System.err.println(parseexception.getMessage());
        }
        try
        {
            filereader.close();
        }
        catch(IOException ioexception)
        {
            System.err.println("Error closing file '" + s + "'.");
        }
    }

    public static void writeDocumentation()
    {
        DocVector docvector = new DocVector(null);
        DocComment doccomment;
        try
        {
            File file = FileUtil.openFile(options.overview(), options.sourcepath());
            FileReader filereader = new FileReader(file);
            doccomment = CommentParser.parse(filereader);
            filereader.close();
        }
        catch(IOException ioexception)
        {
            doccomment = new DocComment();
        }
        top.accept(PackageLister, docvector);
        try
        {
            FileWriter filewriter = new FileWriter(options.destination() + "/stylesheet.css");
            filewriter.write(options.stylesheet());
            filewriter.close();
        }
        catch(IOException ioexception1)
        {
            System.err.println("Writing stylesheet failed.");
        }
        try
        {
            FileWriter filewriter1 = new FileWriter(options.destination() + "/index.html");
            filewriter1.write(HTML.Header("Documentation Overview", "stylesheet.css", options.header()));
            filewriter1.write(HTML.NavBar("*", "", ""));
            PageMaker.getDetailVisitor().writeOverviewDetail(doccomment, top, filewriter1);
            filewriter1.write("<P><HR></P>");
            filewriter1.write(HTML.TableBegin(1, 5, 0));
            filewriter1.write(HTML.TableHead("Documented Packages", 2));
            options.accessible(docvector).accept(SummaryVisitor.Singleton, filewriter1);
            filewriter1.write("</TABLE>\n");
            filewriter1.write("<P><HR></P>");
            filewriter1.write(HTML.Footer(options.footer()));
            filewriter1.close();
        }
        catch(IOException ioexception2)
        {
            System.err.println("Writing overview failed.");
        }
        try
        {
            FileWriter filewriter2 = new FileWriter(options.destination() + "/package-list");
            for(int i = 0; i < docvector.size(); i++)
            {
                String s = ((DocPackage)docvector.get(i)).getFullName();
                if(s.length() > 0)
                    filewriter2.write(s + "\n");
            }

            filewriter2.close();
        }
        catch(IOException ioexception3)
        {
            System.err.println("Writing package-list failed.");
        }
        top.accept(PageMaker, null);
    }

    protected static boolean initCommandLine(String as[])
    {
        boolean flag = false;
        try
        {
            options = new DocOptions(as);
            PageMaker = new HTMLPageVisitor(options);
            PackageLister = new PackageListVisitor(options);
            if(as.length > 0)
                flag = true;
            return flag;
        }
        catch(CLParseException clparseexception)
        {
            System.err.println(clparseexception.getMessage());
        }
        return flag;
    }

    public static DocPackage getTopLevelPackage()
    {
        return top;
    }

    public static String usage()
    {
        return "Usage: gjdoc [options] <source files>\n\nOptions include:\n" + DocOptions.doctemplate.usage();
    }

    public static DocOptions getOptions()
    {
        return options;
    }

    public static void main(String args[])
    {
        java.io.Reader reader = null;
        parser = new GJParser(reader);
        top = new DocPackage(DocEmpty.Only);
        if(initCommandLine(args))
        {
            Vector vector = options.files();
            System.out.println("Number of files: "+vector.size());
            for(int i = 0; i < vector.size(); i++)
                processFile((String)vector.elementAt(i), options.sourcepath());

            writeDocumentation();
        } else
        {
            System.err.println(usage());
            System.exit(-1);
        }
    }

    protected static GJParser parser;
    protected static DocPackage top;
    protected static DocOptions options = null;
    protected static HTMLPageVisitor PageMaker;
    protected static PackageListVisitor PackageLister;
    protected static FileExtensionFilter JavaFilter = new FileExtensionFilter(".java");

}
